// u_c_zzz
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_object_factory;
  interface
    uses Generics.Collections;

    type c_ancestor=
             class
             end; // c_ancestor

         c_a=
             class(c_ancestor)
             end; // c_a
         c_b=
             class(c_ancestor)
             end; // c_b

         c_object_factory< T: Class, Constructor >=
             Class
               m_c_dictionary: TDictionary< string, tClass> ;

               constructor create_object_factory;
               procedure register_class<U>;
               function f_c_instance(p_class_name: string): T;
               destructor Destroy; Override;
             End; // c_object_factory<T>


  implementation
    uses SysUtils, TypInfo, u_display_simple;

    // -- c_object_factory<T>

    Constructor c_object_factory<T>.create_object_factory;
      begin
        Inherited Create;
        m_c_dictionary:= TDictionary< string, tClass>.Create;
      end; // create_object_factory

    procedure c_object_factory<T>.register_class<U>;
      var l_pt_type_info: PTypeInfo;
          l_class_type: tClass;
      begin
        l_pt_type_info := PTypeInfo(TypeInfo(U));
        l_class_type:= GetTypeData(l_pt_type_info).ClassType;
        display(Format('register ''%s'' class %s ',
            [l_pt_type_info.Name, l_class_type.ClassName]));
        m_c_dictionary.Add(l_pt_type_info.Name, l_class_type);
      end; // register_class<U>

    function c_object_factory<T>.f_c_instance(p_class_name: string): T;
      var l_T_class: tClass;
      begin
        l_T_class:= m_c_dictionary[p_class_name];

        // -- if does not case, E2010
        // Result:= l_T_class.Create;

        Result:= T(l_T_class.Create);
      end; // f_c_instance

    Destructor c_object_factory<T>.Destroy;
      begin
        m_c_dictionary.Free;
        Inherited;
      end; // Destroy

    end. // u_c_zzz


